#!/usr/bin/env python2
# -*- coding: utf-8 -*-

from Tkinter import Label
import Tkinter as tk
#from Tkinter import *
import ttk
import tkMessageBox as messagebox
from PIL import Image,ImageTk
import re,os,sqlite3,json
from qrcode import QRCode, constants
import scanSM4
import sys
reload(sys)
sys.setdefaultencoding('utf8')
def get_service_status(service_name):
    # 构建命令
    cmd = 'systemctl  status  "%s"' % service_name
    # 执行命令并获取输出
    try:
        output = os.popen(cmd).read()
    except:
        raise Exception("执行命令失败")

    # 使用正则表达式匹配 "Active:" 后面的状态信息
    pattern = r'Active:\s+(\S*)\s+\((\S*)\)'
    match = re.search(pattern, output)

    if match:
        active_status = match.group(1).strip()
        active_details = match.group(2).strip()
        return active_status, active_details
    else:
        raise Exception("匹配失败")

def get_service_boot(service_name):
    # 构建命令
    cmd = 'systemctl  status  "%s"' % service_name
    # 执行命令并获取输出
    try:
        output = os.popen(cmd).read()
    except:
        raise Exception("执行命令失败")

    # 使用正则表达式匹配 "Loaded:" 后面的状态信息
    pattern = r'Loaded:.*?;\s(\S{6,8});'
    match = re.search(pattern, output)

    if match:
        boot_status = match.group(1).strip()
        return boot_status
    else:
        raise Exception("匹配失败")

def change_label(label,new_text,new_fg,new_bg):
    # 更改标签的文字
    if new_text:
        label.config(text=new_text)
      # 更改标签的文字颜色
    if new_fg:
        label.config(fg=new_fg)

    # 更改标签的背景颜色
    if new_bg:
        label.config(bg=new_bg)

def on_button_sane_click():
    if label_sane_button["text"] == u"运行":
        UI_service_switch("start","ztessc_sane")
    if label_sane_button["text"] == u"停止":
        UI_service_switch("stop","ztessc_sane")
    pass

def on_button_scan_click():
    if label_scan_button["text"] == u"运行":
        UI_service_switch("start","ztessc_scan")
    if label_scan_button["text"] == u"停止":
        UI_service_switch("stop","ztessc_scan")
    pass

def on_check_sane_click():
    if check_sane.get() == 1:
        UI_service_switch("enable","ztessc_sane")
    else:
        UI_service_switch("disable","ztessc_sane")
    pass

def on_check_scan_click():
    if check_scan.get() == 1:
        UI_service_switch("enable","ztessc_scan")
    else:
        UI_service_switch("disable","ztessc_scan")
    pass

def on_open_browse_server_click():
    filename="/usr/bin/lbrowser"
    if os.path.exists(filename):
        exec_bin="/usr/bin/lbrowser"
    else:
        exec_bin="xdg-open"
    try:
        cmd = '%s "http://127.0.0.1:8888"'%exec_bin
        output = os.popen(cmd).read()
    except:
        raise Exception("执行命令失败")


##
def on_checking_click():
    result = messagebox.askyesno("注意", "执行检查需要重启服务,是否继续")
    if result:
        try:
            UI_network_checking()
        except:
            messagebox.showerror("错误","执行检查失败")

def UI_network_checking():
    UI_service_switch("stop","ztessc_scan")
    UI_service_switch("stop","ztessc_sane")
    # 构建命令
    print 'dddd'
    cmd = 'sudo lsof -i :8888,8001'
    #cmd = 'lsof -i :88'
    # 执行命令并获取输出
    try:
        output = os.popen(cmd).read()
    except:
        raise Exception("执行命令失败")

    if output:
        text_tk=tk.Tk()
        text_tk.geometry("600x400")
        text_tk.title("端口占用程序")
        # 禁止用户调整窗口大小
        text_tk.resizable(False, False)  # 禁止调整宽度和高度

        text_root = Text(text_tk, height=200, width=600)
        text_root.pack()
        text_root.insert(END,output)
        text_tk.mainloop()
    else:
         messagebox.showinfo("状态", "正常，端口未被占用")
    pass
    UI_service_switch("start","ztessc_scan")
    UI_service_switch("start","ztessc_sane")



def UI_get_service_boot(check_name,service_name):
    try:
        boot_status = get_service_boot(service_name)
    except Exception as e:
        print '获取服务状态失败 %s'%e
        return

    if boot_status:
        if boot_status == "enabled":
            check_name.set(1)
        if boot_status == "disabled":
            check_name.set(0)


def UI_get_service_status(botton_name,label_status,service_name):
    try:
        active_status, active_details = get_service_status(service_name)
    except Exception as e:
        print '获取服务状态失败 %s'%e
        return
    if active_status:
        if active_status == "active" and active_details == "running":
            botton_name.config(text="停止")
            change_label(label_status,"运行中","#12be0a",None)
        if active_status == "active" and active_details == "waiting":
            change_label(label_status,"等待运行","#ffffff",None)
        if active_status == "inactive":
            botton_name.config(text="运行")
            change_label(label_status,"停止","#da0000",None)
        if active_status == "activating" :
            botton_name.config(text="停止")
            change_label(label_status,"启动中","#ffffff",None)
        if active_status == "deactivating" :
            change_label(label_status,"停止过程中","#ffffff",None)
        if active_status == "failed" :
            change_label(label_status,"启动失败","#ffff00",None)
        if active_status == "reloading" :
            change_label(label_status,"正在重新加载配置","#ffffff",None)
    else:
        print '获取状态类型： %s'%(active_status,active_details)
        pass
    #messagebox.showinfo("消息", "按钮被点击了！")
    pass

def UI_service_switch(switch,service_name):
    # 构建命令
    if switch:
        if switch == "start":
            cmd = 'sudo systemctl  start  "%s"' % service_name
        if switch == "stop":
            cmd = 'sudo systemctl  stop  "%s"' % service_name
        if switch == "enable":
            cmd = 'sudo systemctl  enable  "%s"' % service_name
        if switch == "disable":
            cmd = 'sudo systemctl  disable  "%s"' % service_name
    else:
        return None
    # 执行命令并获取输出
    try:
        output = os.popen(cmd).read()
    except:
        return None
    # 处理输出

def on_restore_sane_button_click():
    result = messagebox.askyesno("注意", "恢复程序，将导致当前扫描任务中断\n是否继续")
    if result:
        bak_file="/opt/ztessc_scan/twain_client.tar"
        if os.path.exists(bak_file):
            try:
                UI_service_switch("stop","ztessc_sane")
		os.popen('sudo rm -rf /opt/ztessc_scan/twain_client').read()
                cmd = 'sudo tar -xf %s  -C /opt/ztessc_scan/' % bak_file
                os.popen(cmd).read()
                UI_service_switch("start","ztessc_sane")
                pass
                messagebox.showinfo("任务完成", "重置成功,已重新启动服务")
            except:
                messagebox.showerror("错误","恢复失败")
        else:
            messagebox.showerror("错误","恢复文件不存在,请重新安装软件")

    pass
def on_restore_scan_button_click():
    result = messagebox.askyesno("注意", "恢复程序，将导致当前扫描任务中断\n是否继续")
    if result:
        bak_file1="/opt/ztessc_scan/venv.tar"
        bak_file2="/opt/ztessc_scan/web_ui.tar"
        if os.path.exists(bak_file1) and os.path.exists(bak_file2):
            try:
                UI_service_switch("stop","ztessc_scan")
		os.popen('sudo rm -rf /opt/ztessc_scan/venv').read()
		os.popen('sudo rm -rf /opt/ztessc_scan/web_ui').read()
                cmd = 'sudo tar -xf %s  -C /opt/ztessc_scan/' % bak_file1
                os.popen(cmd).read()
                cmd = 'sudo tar -xf %s  -C /opt/ztessc_scan/' % bak_file2
                os.popen(cmd).read()
                UI_service_switch("start","ztessc_scan")
                pass
                messagebox.showinfo("任务完成", "重置成功,已重新启动服务")
            except:
                messagebox.showerror("错误","恢复失败")
        else:
            messagebox.showerror("错误","恢复文件不存在，请重新安装软件")

###########################################################################################################################

def UI_sqlite3_config_tools(switch,code,val):
    bak_file='/opt/ztessc_scan/web_ui/data/data.db'
   # cmd = 'chmod 666 %s ' % bak_file
   # try:
   #     output = os.popen(cmd).read()
   # except:
   #     return None

    if not os.path.exists(bak_file):
        raise Exception("文件不存在")
    # 连接到数据库
    conn = sqlite3.connect(bak_file)
    cursor = conn.cursor()
    
    if switch == "update":
        # 更新记录
        cursor.execute("UPDATE config SET val = ? WHERE code = ?", (val, code))
        # 提交更改
        conn.commit()

    if switch == "select":
        # 执行查询
        cursor.execute("SELECT val FROM config WHERE code = ?", (code,))

        # 获取结果
        result = cursor.fetchone()
        if result:
            val = result[0]
            #print val
            #print("val:", val)
        else:
            val="read  data db error"
            print("No record found for code:", code)
 
    #关闭连接
    conn.close()
    return val


def generate_qr_code(data):  
    qr = QRCode(  
        version=1,  
        error_correction=constants.ERROR_CORRECT_L,  
        box_size=10,  
        border=4,  
    )  
    qr.add_data(data)  
    qr.make(fit=True)  
    img = qr.make_image(fill_color="black", back_color="white")  
    # 将 PIL 图像转换为 RGB 模式，因为 Tkinter 的 PhotoImage 不支持其他模式  
    img = img.convert("RGB")  
    # 这里不直接返回 ImageTk.PhotoImage，因为当这个函数返回时，局部变量可能会被垃圾回收  
    # 而是返回原始的 PIL 图像，然后在 Tkinter 主线程中转换它  

    return img  
  
def show_qr_code(root, data):  
    # 生成 QR 码 PIL 图像  
    pil_image = generate_qr_code(data)
    # 将 PIL 图像转换为 Tkinter 可以显示的格式  
    tk_image = ImageTk.PhotoImage(pil_image)  
    # 创建 Label 来显示图像  
    label = Label(root, image=tk_image)  
    label.image = tk_image  # 保持对图像的引用，防止它被垃圾回收  
    label.pack()  # 使用 pack() 布局管理器来显示标签  
def show_qc(QR_str):
    root1 = tk.Toplevel()  
    root1.title("二维码")  
    show_qr_code(root1, QR_str)  
    root1.mainloop()

def UI_Entry_text(uiEntry_name,text):
    uiEntry_name.delete(0, tk.END)
    uiEntry_name.insert(0, text) 



def save_to_json(data, filename='/etc/ztessc_scan.json'):
    """
    将两个文本字符串保存为 JSON 文件。

    :param text1: 第一个文本字符串
    :param text2: 第二个文本字符串
    :param filename: 保存的文件名，默认是 'data.json'
    """

    print(data)
    with open(filename, 'w') as json_file:
        print("使用 json.dump 将字典数据写入文件")
        json_file.write(data)

def load_from_json(filename='/etc/ztessc_scan.json'):
    """
    从 JSON 文件加载两个文本字符串。

    :param filename: 加载的文件名，默认是 'data.json'
    :return: 包含两个文本字符串的字典
    """
    try:
        with open(filename, 'r') as json_file:
            data = json_file.read()
            return data
    except Exception as e:
        print("文件 %s 不是有效的 JSON 文件 %s"%(filename,e))
        return None



def on_license_config_click():
    qwe=scanSM4.scanSM4()
    def on_show_qc_click():
        show_qc(e1.get())
    def on_copy_clipboard_click():
        license_config_tk.clipboard_clear()
        license_config_tk.clipboard_append(e1.get())
        license_config_tk.update()
    def on_get_clipboard_click():
        UI_Entry_text(e2,license_config_tk.clipboard_get())
    def on_license_config_closing():
        license_config_tk.destroy()
    def on_save():
        try:
            save_to_json(e2.get())
            data = load_from_json()
            
            text=qwe.license_ckeck(data)
        except ValueError:
            messagebox.showinfo("信息", "注册成功，校验正确")
            on_license_config_closing()
        except Exception as e:
            print(e)
            messagebox.showinfo("信息", "注册信息错误，请重新填写")
            pass
    def on_save_exit():
        on_license_config_closing()


    license_config_tk=tk.Tk()
    license_config_tk.geometry("950x150")
    license_config_tk.title("授权")
    # 创建一个自定义样式
    style = ttk.Style()
    style.configure("Custom.TCheckbutton", background="lightblue")  # 设置边框颜色为红色
    style.configure("Custom.TButton", background="lightblue")  # 设置边框颜色为红色

        # 禁止用户调整窗口大小
    #webui_config_tk.resizable(False, False)  # 禁止调整宽度和高度
    backcloth_color='lightblue'
    license_config_tk.configure(bg=backcloth_color)  # 背景颜色设置为浅蓝色
    # 设置所有控件的默认背景颜色
    license_config_tk.option_add("*Button.Background", backcloth_color)  # 所有按钮的默认背景颜色
    license_config_tk.option_add("*Label.Background", backcloth_color)  # 所有标签的默认背景颜色
    license_config_tk.option_add("*Background", backcloth_color)  # 其他控件的默认背景颜色
    license_config_tk.option_add("*bordercolor", backcloth_color)

    Label(license_config_tk, text="机器码：").grid(row=0, column=0, padx=10, pady=10)
    Label(license_config_tk, text="注册码：").grid(row=1, column=0, padx=10, pady=10)
    Label(license_config_tk, text="联系人：龙芯中科（武汉）技术有限公司，王治国，18901223263").grid(row=2, column=1, padx=10, pady=10)
    e1 = tk.Entry(license_config_tk,width=50)
    
    e2 = tk.Entry(license_config_tk,width=50)
    e1.grid(row=0, column=1, padx=10, pady=10)
    e2.grid(row=1, column=1, padx=10, pady=10)

    data = load_from_json()

    print(data)
    
    UI_Entry_text(e1,qwe.init_key())
    UI_Entry_text(e2,data)
    #e1.config(state=tk.DISABLED)

    save_button = ttk.Button(license_config_tk, text="保存",style="Custom.TButton",command=on_save)
    save_button.grid(row=0, column=2, padx=10, pady=10)
    save_button1 = ttk.Button(license_config_tk, text="取消",style="Custom.TButton",command=on_save_exit)
    save_button1.grid(row=1, column=2, padx=10, pady=10)
    ##显示二维码

    license_config_tk.protocol("WM_DELETE_WINDOW", on_license_config_closing)
    license_config_tk.mainloop()





def on_webui_config_click():
    UI_service_switch("stop","ztessc_scan")
    def on_webui_config_closing():
        UI_service_switch("start","ztessc_scan")
        webui_config_tk.destroy()
    def on_save():
        UI_sqlite3_config_tools("update","EIS_IP",e1.get())
        UI_sqlite3_config_tools("update","BARCODE_RULE",e2.get())
        on_webui_config_closing()
    def on_save_exit():
        on_webui_config_closing()
    def on_e1_set():
        UI_Entry_text(e1,"http://<domain>/evssys/")
    def on_e1_set2():
        UI_Entry_text(e1,"http://10.3.154.218:8080/evssys")
    def on_e2_set():
        UI_Entry_text(e2,"^(WH)(-BX|-CW|-YW|-ZC|-ZJ|-QS|-WZ|-XC)(\d*)")
    webui_config_tk=tk.Tk()
    webui_config_tk.geometry("750x150")
    webui_config_tk.title("设置")
    # 创建一个自定义样式
    style = ttk.Style()
    style.configure("Custom.TCheckbutton", background="lightblue")  # 设置边框颜色为红色
    style.configure("Custom.TButton", background="lightblue")  # 设置边框颜色为红色

        # 禁止用户调整窗口大小
    #webui_config_tk.resizable(False, False)  # 禁止调整宽度和高度
    backcloth_color='lightblue'
    webui_config_tk.configure(bg=backcloth_color)  # 背景颜色设置为浅蓝色
    # 设置所有控件的默认背景颜色
    webui_config_tk.option_add("*Button.Background", backcloth_color)  # 所有按钮的默认背景颜色
    webui_config_tk.option_add("*Label.Background", backcloth_color)  # 所有标签的默认背景颜色
    webui_config_tk.option_add("*Background", backcloth_color)  # 其他控件的默认背景颜色
    webui_config_tk.option_add("*bordercolor", backcloth_color)

    Label(webui_config_tk, text="条形码正则：").grid(row=1, column=0, padx=10, pady=10)
    Label(webui_config_tk, text="服务端网址：").grid(row=0, column=0, padx=10, pady=10)
    sql_text1=UI_sqlite3_config_tools("select","EIS_IP",None)
    sql_text2=UI_sqlite3_config_tools("select","BARCODE_RULE",None)

    e1 = tk.Entry(webui_config_tk,width=50)
    e2 = tk.Entry(webui_config_tk,width=50)
    e1.grid(row=0, column=1, padx=10, pady=10)
    e2.grid(row=1, column=1, padx=10, pady=10)
    UI_Entry_text(e1,sql_text1)
    UI_Entry_text(e2,sql_text2)
    e1_default1_button = ttk.Button(webui_config_tk, text="空白",style="Custom.TButton",command=on_e1_set)
    e1_default1_button.grid(row=0, column=2, padx=10, pady=10)
    e1_default2_button = ttk.Button(webui_config_tk, text="预设",style="Custom.TButton",command=on_e1_set2)
    e1_default2_button.grid(row=0, column=3, padx=10, pady=10)
    e1_default3_button = ttk.Button(webui_config_tk, text="预设",style="Custom.TButton",command=on_e2_set)
    e1_default3_button.grid(row=1, column=2, padx=10, pady=10)
    save_button = ttk.Button(webui_config_tk, text="保存",style="Custom.TButton",command=on_save)
    save_button.grid(row=2, column=2, padx=10, pady=10)
    save_button1 = ttk.Button(webui_config_tk, text="取消",style="Custom.TButton",command=on_save_exit)
    save_button1.grid(row=2, column=3, padx=10, pady=10)

    webui_config_tk.protocol("WM_DELETE_WINDOW", on_webui_config_closing)
    webui_config_tk.mainloop()





###########################################################################################################################
# 创建主窗口

root = tk.Tk()
root.geometry("600x250")
# 禁止用户调整窗口大小
root.resizable(False, False)  # 禁止调整宽度和高度

# 设置主窗口的背景颜色

backcloth_color='lightblue'
root.configure(bg=backcloth_color)  # 背景颜色设置为浅蓝色
# 设置所有控件的默认背景颜色
root.option_add("*Button.Background", backcloth_color)  # 所有按钮的默认背景颜色
root.option_add("*Label.Background", backcloth_color)  # 所有标签的默认背景颜色
root.option_add("*Background", backcloth_color)  # 其他控件的默认背景颜色
root.option_add("*bordercolor", backcloth_color)


# 创建一个自定义样式
style = ttk.Style()
style.configure("Custom.TCheckbutton", background="lightblue")  # 设置边框颜色为红色
style.configure("Custom.TButton", background="lightblue")  # 设置边框颜色为红色

root.title("影像扫描系统")

# 加载图像
image = Image.open('/opt/ztessc_scan/favicon.ico')
icon = ImageTk.PhotoImage(image)

# 设置窗口图标
root.tk.call('wm', 'iconphoto', root._w, icon)

# 创建一个标签并放置在第一行第一列
label_sane_name = Label(root, text="驱动服务：")
label_sane_name.grid(row=0, column=0, padx=10, pady=10)
label_sane_status = Label(root, text="状态")
label_sane_status.grid(row=0, column=1, padx=10, pady=10)


# 创建一个按钮并放置在第一行第三列
label_sane_button = ttk.Button(root, text="运行" ,style="Custom.TButton", command=on_button_sane_click)
label_sane_button.grid(row=0, column=2, padx=10, pady=10)


# 定义一个变量来保存复选框的状态
check_sane = tk.IntVar(value=0)

# 创建一个复选框，并将其与上面定义的变量关联
check_sane_button1 = ttk.Checkbutton(root, text="开机自启动",style="Custom.TCheckbutton", variable=check_sane,command=on_check_sane_click)
check_sane_button1.grid(row=0, column=3, padx=10, pady=10)  # 将复选框放置到窗口中


# 创建一个标签并放置在第二行第一列
label_scan_name = Label(root, text="影像服务：")
label_scan_name.grid(row=1, column=0, padx=10, pady=10)
label_scan_status = Label(root, text="状态")
label_scan_status.grid(row=1, column=1, padx=10, pady=10)


# 创建一个按钮并放置在第二行第三列
label_scan_button = ttk.Button(root, text="运行",style="Custom.TButton",command=on_button_scan_click)
label_scan_button.grid(row=1, column=2, padx=10, pady=10)
# 定义一个变量来保存复选框的状态
check_scan = tk.IntVar(value=0)

# 创建一个复选框，并将其与上面定义的变量关联
check_scan_button1 = ttk.Checkbutton(root, text="开机自启动",style="Custom.TCheckbutton", variable=check_scan,command=on_check_scan_click)
check_scan_button1.grid(row=1, column=3, padx=10, pady=10)  # 将复选框放置到窗口中


label_checking_button = ttk.Button(root, text="打开影像系统",style="Custom.TButton",command=on_open_browse_server_click)
label_checking_button.grid(row=3, column=0, padx=10, pady=10)
# 创建一个按钮并放置在第三行第1列
label_checking_button = ttk.Button(root, text="端口检测",style="Custom.TButton",command=on_checking_click)
label_checking_button.grid(row=2, column=0, padx=10, pady=10)
# 创建一个按钮并放置在第三行第1列
label_checking_button = ttk.Button(root, text="影像设置",style="Custom.TButton",command=on_webui_config_click)
#label_checking_button.grid(row=2, column=1, padx=10, pady=10)
label_checking_button = ttk.Button(root, text="激活",style="Custom.TButton",command=on_license_config_click)
label_checking_button.grid(row=2, column=2, padx=10, pady=10)

# 创建一个按钮并放置在第三行第1列
label_restore_sane_button = ttk.Button(root, text="重置驱动程序",style="Custom.TButton",command=on_restore_sane_button_click)
label_restore_sane_button.grid(row=0, column=4, padx=10, pady=10)
# 创建一个按钮并放置在第三行第1列
label_restore_scan_button = ttk.Button(root, text="重置影像程序",style="Custom.TButton",command=on_restore_scan_button_click)
label_restore_scan_button.grid(row=1, column=4, padx=10, pady=10)




def update_label():
    # 更新标签文本
    UI_get_service_status(label_sane_button,label_sane_status,"ztessc_sane")
    UI_get_service_status(label_scan_button,label_scan_status,"ztessc_scan")
    UI_get_service_boot(check_sane,"ztessc_sane")
    UI_get_service_boot(check_scan,"ztessc_scan")
    # 再次安排此函数在 1000 毫秒（1 秒）后调用
    root.after(1000, update_label)

# 安排 update_label 函数在 1000 毫秒（1 秒）后调用
root.after(1000, update_label)

root.mainloop()
